unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls,

  OptsDlg,
  FLXTypes, FLXPlay, Buttons, FileCtrl, MPlayer;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    Panel2: TPanel;
    Panel3: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    Panel4: TPanel;
    FilterComboBox1: TFilterComboBox;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Panel5: TPanel;
    ScrollBox: TScrollBox;
    FLXPlayer: TFLXPlayer;
    SplitPanel: TPanel;
    Panel1: TPanel;
    CmdBtn: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    OptionsBtn: TButton;
    procedure OpenBtnClick(Sender: TObject);
    procedure NextFrameBtnClick(Sender: TObject);
    procedure DitherBtnClick(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure FirstFrameBtnClick(Sender: TObject);
    procedure PrevFrameBtnClick(Sender: TObject);
    procedure PauseBtnClick(Sender: TObject);
    procedure ContinueBtnClick(Sender: TObject);
    procedure LastFrameBtnClick(Sender: TObject);
    procedure FLXPlayerPlayerEvent(Sender: TObject;
      EventID: TFLXPlayerEventID);
    procedure SplitPanelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SplitPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CmdBtnClick(Sender: TObject);
    procedure OptionsBtnClick(Sender: TObject);
  private
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.OpenBtnClick(Sender: TObject);
var err: integer;
    msg: string;
begin
  if FileListBox1.ItemIndex <> -1 then
  begin
    FLXPlayer.CloseAnimation;
    InvalidateRect( FLXPlayer.Handle, nil, true );
    FLXPlayer.FileName := FileListBox1.Items[FileListBox1.ItemIndex];
    err := FLXPlayer.LoadAnimation;
    if err <> loadSUCCESS then
    begin
      case err of
        loadFLXALREADYOPEN :
          msg := 'Selected animation file is already open.';
        loadFLXNOTFOUND:
          msg := 'Could not find selected file.';
        loadFLXIOERROR:
          msg := 'An I/O error has occurred while opening the animation file.';
        loadNOTAFLX:
          msg := 'Selected file is not a valid FLI/FLC animation.';
        loadOUTOFMEMORY:
          msg := 'There is not enough memory to store the selected animation file.';
      end;
      StatusBar.SimpleText := msg;
      exit;
    end;
  end;
end;

procedure TMainForm.NextFrameBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaNextFrame;
end;

procedure TMainForm.DitherBtnClick(Sender: TObject);
begin
  //FLXPlayer.Dither := DitherBtn.Down;
end;

procedure TMainForm.FileListBox1DblClick(Sender: TObject);
begin
  OpenBtnClick( nil );
  FLXPlayer.Action := flxaPlay;
end;

procedure TMainForm.FirstFrameBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaFirstFrame;
end;

procedure TMainForm.PrevFrameBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaPrevFrame;
end;

procedure TMainForm.PauseBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaPause;
end;

procedure TMainForm.ContinueBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaContinue;
end;

procedure TMainForm.LastFrameBtnClick(Sender: TObject);
begin
  FLXPlayer.Action := flxaLastFrame;
end;

procedure TMainForm.FLXPlayerPlayerEvent(Sender: TObject;
  EventID: TFLXPlayerEventID);
var s: string;
begin
  s := '(?)';
  case EventID of
    flxeLoaded:
      begin
        case FLXPlayer.FLXType of
          fftFLI: s := 'FLI';
          fftFLC: s := 'FLC';
        end;
        s := s + ' animation loaded (' + IntToStr( FLXPlayer.FrameCount ) + ' frames)';
      end;
    flxeClosed:
      s := 'Animation closed';
    flxeStart:
      s := 'Play cmd executed';
    flxeStop:
      s := 'Stop cmd executed';
    flxePause:
      s := 'Pause cmd executed';
    flxeContinue:
      s := 'Continue Play cmd executed';
    flxeFrame:
      begin
        FmtStr( s, 'Loop:%0.7d Frame:%0.4d FPS:%0.3d', [FLXPlayer.LoopIndex,FLXPlayer.FrameIndex,FLXPlayer.FPS] );
        StatusBar.Panels[0].Text := s;
        s := 'Frame event received';
      end;
    flxeLoop:
      s := 'New loop event received';
  end;
  StatusBar.Panels[1].Text := s;
end;

procedure TMainForm.SplitPanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetCapture( Handle );
end;

procedure TMainForm.SplitPanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
end;

procedure TMainForm.CmdBtnClick(Sender: TObject);
begin
  case TSpeedButton(Sender).Tag of
    0: // Play
      FLXPlayer.Action := flxaPlay;
    1: // Pause
      FLXPlayer.Action := flxaPause;
    2: // Continue
      FLXPlayer.Action := flxaContinue;
    3: // Stop
      FLXPlayer.Action := flxaStop;
    4: // First frame
      FLXPlayer.Action := flxaFirstFrame;
    5: // Previous frame
      FLXPlayer.Action := flxaPrevFrame;
    6: // Next frame
      FLXPlayer.Action := flxaNextFrame;
    7: // Last frame
      FLXPlayer.Action := flxaLastFrame;
  end;
end;

procedure TMainForm.OptionsBtnClick(Sender: TObject);
begin
  if OptionsDlg.ShowModal = mrOk then
  begin
  end;
end;

end.
